
    rng('default');
    rng('shuffle');
    seed = floor(rand() * 100000000);
    fprintf('seed:%d\n', seed);
    seed = 1;
    rng(seed);

    n = 256;
    m = 20;
    r = 4;


    A = randn(m, n);
    A = A - repmat(mean(A, 1), m, 1);
    A = A ./ repmat(sqrt(sum(A .* A)), m, 1);
    
    [U, S, V] = svd(A, 'econ');
    PCAV = V(:, 1:r);
    initx = PCAV;
    tmp = A * PCAV; maxvar = sum(tmp(:) .* tmp(:));
    D = diag(S(1:r, 1:r));
    Dsq = D.^2;
    lambda = 1;
    
    Xinitial.main = PCAV;
    Lu = norm(Dsq)^2 * 8;
    Ll = Lu / 8;
    tol = 1e-8*n*r;
    maxiter = 10000;
    time1 = 0; time2 = 0; time3 = 0; time4 = 0;
    fv1 = -inf; fv2 = -inf;

    [xopt1, iter, time1, fv1, nD, sparsity1, avar] = Driver_ManPG(Xinitial, A, Dsq, lambda, Lu, tol, maxiter);

    [xopt2, iter, time2, fv2, nD, sparsity2, avar] = Driver_RPG(Xinitial, A, Dsq, lambda, Lu, tol, maxiter);

    [xopt1, iter, time1, fv1, nD, sparsity1, avar] = Driver_ManPG_Ada(Xinitial, A, Dsq, lambda, Lu, tol, maxiter, min(fv1, fv2));

    [xopt2, iter, time2, fv2, nD, sparsity2, avar] = Driver_RPG_Ada(Xinitial, A, Dsq, lambda, Lu, tol, maxiter, min(fv1, fv2));

    [xopt3, iter, time3, fv3, nD, sparsity3, avar] = Driver_AManPG(Xinitial, A, Dsq, lambda, Ll, Lu, tol, maxiter, min(fv1, fv2));

    [xopt4, iter, time4, fv4, nD, sparsity4, avar] = Driver_ARPG(Xinitial, A, Dsq, lambda, Ll, Lu, tol, maxiter, min(fv1, fv2));

[time1, time2, time3, time4]
