
    rng('default');
    rng('shuffle');
    seed = floor(rand() * 100000000);
    seed = 1;
    fprintf('seed:%d\n', seed);
    rng(seed);

    n = 1000;
    m = 10;
    r = 5;

    A = randn(m, n);
    A = A - repmat(mean(A, 1), m, 1);
    A = A ./ repmat(sqrt(sum(A .* A)), m, 1);
    
    [U, S, V] = svd(A, 'econ');
    PCAV = V(:, 1:r);
    initx = PCAV;
    tmp = A * PCAV; maxvar = sum(tmp(:) .* tmp(:));
    D = diag(S(1:r, 1:r));
    Dsq = D.^2;
    lambda = 0.5;
    
    Xinitial.main = PCAV;
%     L = norm(Dsq(:), 'fro')^2*2; % esitmation of the Lipschitz constant. It is important for performance!!!
    Lu = max(Dsq) * 2;
    Ll = Lu*0.8;
    tol = 1e-8*n*r;
    maxiter = 100000;
    RPMWHmaxiter = 20;
    RPMWHtol = 1e-3;
    
    fprintf('ManPG\n');
    [xopt1, iter1, time1, fv1, nD1, sparsity1, avar1, fs1] = Driver_ManPG(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

    fprintf('RPG\n');
    [xopt2, iter2, time2, fv2, nD2, sparsity2, avar2, fs2] = Driver_RPG(Xinitial, A, lambda, Lu, tol, maxiter, -inf, RPMWHmaxiter, RPMWHtol);
    
    fprintf('ManPG-Ada\n');
    [xopt3, iter3, time3, fv3, nD3, sparsity3, avar3, fs3] = Driver_ManPG_Ada(Xinitial, A, lambda, Lu, tol, maxiter, -inf);

    fprintf('AManPG\n');
    [xopt4, iter4, time4, fv4, nD4, sparsity4, avar4, fs4] = Driver_AManPG(Xinitial, A, lambda, Lu, tol, maxiter, -inf);
    
    fprintf('ARPG\n');
    [xopt5, iter5, time5, fv5, nD5, sparsity5, avar5, fs5] = Driver_ARPG(Xinitial, A, lambda, Ll, Lu, tol, maxiter, -inf, RPMWHmaxiter, RPMWHtol);


    [time1, time2, time3, time4, time5]
